#include <GUIConstantsEx.au3>
#include <ComboConstants.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>

#include "Encoding.au3"

Global Const $iMaxTranslateLenght = 376

$hGUI = GUICreate("Google - ", 420, 390)

$nStatus_Label = GUICtrlCreateLabel("", 20, 360, 310, 17)
GUICtrlSetFont(-1, 10, 800)
GUICtrlSetColor(-1, 0x0000FF)

GUICtrlCreateLabel("  :", 20, 12)
$nLangSel_Combo1 = GUICtrlCreateCombo("", 190, 10, 200, 50, BitOr($GUI_SS_DEFAULT_COMBO, $CBS_DROPDOWNLIST))
_SetTranslateLangs_Proc($nLangSel_Combo1, "auto -  ", "auto -  |")

GUICtrlCreateLabel(" :", 20, 37)
$nLangSel_Combo2 = GUICtrlCreateCombo("", 190, 35, 200, 50, BitOr($GUI_SS_DEFAULT_COMBO, $CBS_DROPDOWNLIST))
_SetTranslateLangs_Proc($nLangSel_Combo2, "en - ")

$nInvertLangs_Button = GUICtrlCreateButton("^v", 395, 13, 20, 40)

GUICtrlCreateLabel(" :", 20, 60)
$nInputText_Edit = GUICtrlCreateEdit(ClipGet(), 20, 80, 380, 120)

$nInvertText_Button = GUICtrlCreateButton("^v", 380, 205, 20, 20)

GUICtrlCreateLabel(" :", 20, 210)
$nOutputText_Edit = GUICtrlCreateEdit("", 20, 230, 380, 120, $GUI_SS_DEFAULT_EDIT)

$nTranslate_Btn = GUICtrlCreateButton("", 330, 360, 70, 25, BitOr($GUI_SS_DEFAULT_BUTTON, $BS_DEFPUSHBUTTON))

GUISetState(@SW_SHOW, $hGUI)

While 1
    $nMsg = GUIGetMsg()
	
    Switch $nMsg
        Case $GUI_EVENT_CLOSE
            Exit
        Case $nInvertLangs_Button
            $sCombo1 = GUICtrlRead($nLangSel_Combo1)
            $sCombo2 = GUICtrlRead($nLangSel_Combo2)
			
			If StringLeft($sCombo1, 4) <> "auto" Then
				GUICtrlSetData($nLangSel_Combo1, $sCombo2)
				GUICtrlSetData($nLangSel_Combo2, $sCombo1)
			EndIf
        Case $nInvertText_Button
			$sEdit1 = GUICtrlRead($nInputText_Edit)
			$sEdit2 = GUICtrlRead($nOutputText_Edit)
			
            GUICtrlSetData($nInputText_Edit, $sEdit2)
            GUICtrlSetData($nOutputText_Edit, $sEdit1)
        Case $nTranslate_Btn
			$sText = GUICtrlRead($nInputText_Edit)
			$sLang1 = StringRegExpReplace(GUICtrlRead($nLangSel_Combo1), " - .*$", '')
            $sLang2 = StringRegExpReplace(GUICtrlRead($nLangSel_Combo2), " - .*$", '')
			
			If $sText = '' Then
				MsgBox(48, '', ' ', 0, $hGUI)
				ContinueLoop
            EndIf
			
			If $sLang1 = $sLang2 Then
				MsgBox(48, '', '   .', 0, $hGUI)
				ContinueLoop
			EndIf
			
            $iTxtLen = StringLen($sText)
			
            If $iTxtLen > $iMaxTranslateLenght Then
				$iAsk = MsgBox(4, '', '   , ?' & @CRLF & ' 376 (: ' & $iTxtLen & ')', 0, $hGUI)
				
				If $iAsk = 6 Then
					$sText = StringMid($sText, 1, 376)
				EndIf
			EndIf
			
            GUICtrlSetBkColor($nOutputText_Edit, 0xFFD7D7)
			GUICtrlSetData($nOutputText_Edit, "")
            GUICtrlSetState($nTranslate_Btn, $GUI_DISABLE)
            GUICtrlSetData($nStatus_Label, ", ...")
			
			$sResult = _GoogleTranslateString($sText, $sLang1 & "|" & $sLang2, True)
			
			GUICtrlSetBkColor($nOutputText_Edit, 0xFFFFFF)
            GUICtrlSetData($nOutputText_Edit, $sResult)
            GUICtrlSetState($nTranslate_Btn, $GUI_ENABLE)
            GUICtrlSetData($nStatus_Label, "")
			
			AdlibRegister("_ClearStatusData_Proc", 5000)
    EndSwitch
WEnd

Func _GoogleTranslateString($sText, $sLangPair = -1, $bEncodeURL = False)
	If $sLangPair = -1 Then
		$sLangPair = "auto|en"
	EndIf
	
	If $bEncodeURL Then
		$sText = _Encoding_URLToHex($sText)
	EndIf
	
	$sResult = BinaryToString(InetRead('http://google.ru/translate_t?langpair=' & $sLangPair & '&text=' & $sText))
	
	If StringRight($sLangPair, 2) = "ru" Then
		$sResult = _Encoding_KOI8To1251($sResult)
	EndIf
	
	$aResult = StringRegExp($sResult, '(?si)(?:onmouseout=".*?>)(.*?)(?=</SPAN>)', 3)
	$sResult = ''
	
	For $i = 0 To UBound($aResult)-1
		$sResult &= $aResult[$i]
	Next
	
	$sResult = StringReplace($sResult, '<br>', @CRLF)
	
	If _Encoding_IsUTF8Format($sResult) Then
		$sResult = _Encoding_UTF8ToANSI($sResult)
	EndIf
	
	If $bEncodeURL Then
		$sResult = _URLDecode($sResult)
	EndIf
	
	Return $sResult
EndFunc

Func _SetTranslateLangs_Proc($nComboID, $sDefault = "", $sAdd = "")
	$vTest = BinaryToString(InetRead('http://translate.google.ru'))
	$sRet = StringRegExp($vTest, '<option\s*value="(.*?)">(.*?)</option>', 3)
	
	$sLangs = ""
	
	For $i = 0 To UBound($sRet)-1
		If Mod($i, 2) <> 0 Then
			$sRet[$i] = _Encoding_KOI8To1251($sRet[$i])
			
			$sLangs &= $sRet[$i-1] & " - " & StringUpper(StringLeft($sRet[$i], 1)) & StringTrimLeft($sRet[$i], 1) & "|"
			$i += 1
		EndIf
	Next
	
	GUICtrlSetData($nComboID, $sAdd & StringRegExpReplace($sLangs, "\|+$", ""), $sDefault)
EndFunc

Func _ClearStatusData_Proc()
	GUICtrlSetData($nStatus_Label, "")
EndFunc

; #FUNCTION# ==============================================
; Description ...: Encodes text for use in URLs
; Parameters ....: $sURL - IN - The text to encode
; Return values .: The encoded text
; Author ........: Stephen Podhajecki {gehossafats at netmdc. com}
; Remarks .......: Replaces defined characters with escaped hex values for url encoding.
;                  Encoding based on information provided here: http://www.blooberry.com/indexdot/html/topics/urlencoding.htm
; Related .......: _URLDecode
; ========================================================
Func _URLEncode($sURL)
    Local $aEncodable[13] = ['"',"'","<",">","\","^","[","]","`","+","$",",","#"]
    
	;encode % first because encoding will add more % to the url
    Local $sTemp = StringReplace($sURL,"%","%25")
    
	;encode non-printable and space
    For $x = 0 To 32
        $sTemp = StringReplace($sTemp,Chr($x),"%"&Hex($x,2))
    Next
   
	;encode "unsafe"
    For $x = 0 To UBound($aEncodable)-1
        $sTemp = StringReplace($sTemp,$aEncodable[$x],"%"&Hex(Asc($aEncodable[$x]),2))
    Next
    
	;encode upper ascii and {}|~_
    For $x = 123 To 255
        $sTemp = StringReplace($sTemp,Chr($x),"%"&Hex($x,2))
    Next
	
    Return $sTemp
EndFunc

; #FUNCTION# ==============================================
; Description ...: Decodeds text for use in URLs
; Parameters ....: $sURL - IN - The text to decode
; Return values .: The decoded text
; Author ........: Stephen Podhajecki {gehossafats at netmdc. com}
; Remarks .......: Replaces escaped hex values for url encoding with ascII characters.
;                  Decoding based on information provided here: http://www.blooberry.com/indexdot/html/topics/urlencoding.htm
; Related .......: _URLEncode
; =========================================================
Func _URLDecode($sURL)
    Local $aEncodable[13] = ['"',"'","<",">","\","^","[","]","`","+","$",",","#"]
    ;decode non-printable and space
    Local $sTemp = $sURL
	
    For $x = 0 To 32
        $sTemp = StringReplace($sTemp,"%"&Hex($x,2),Chr($x))
    Next
	
    ;decode "unsafe"
    For $x = 0 To UBound($aEncodable)-1
        $sTemp = StringReplace($sTemp,"%"&Hex(Asc($aEncodable[$x]),2),$aEncodable[$x])
    Next
	
    ;decode upper ascii and {}|~_
    For $x = 123 To 255
        $sTemp = StringReplace($sTemp,"%"&Hex($x,2),Chr($x))
    Next
	
    ;decode % last 
    $sTemp = StringReplace($sTemp,"%25","%")
    $sTemp = _ConvertEntities($sTemp)
	
    Return $sTemp
EndFunc

; #FUNCTION# =====================================================================================================================
; Description ...: _ConvertEntities
; Parameters ....: $sURL - IN - The Text to convert
; Return values .: Success - Converted string
; Author ........: Stephen Podhajecki {gehossafats at netmdc. com}
; Remarks .......: Replaces HTML escape sequences with character representation
;                  Based on information found here: http://www.theukwebdesigncompany.com/articles/entity-escape-characters.php
;                  nbsp is changed to 32 instead of 160
; Related .......: 
; ================================================================================================================================
Func _ConvertEntities($sURL)
    Local $sTemp = $sUrl
    Local $aEntities[96][2]=[["&quot;",34],["&amp;",38],["&lt;",60],["&gt;",62],["&nbsp;",3],["&nbsp;",32] _
        ,["&iexcl;",161],["&cent;",162],["&pound;",163],["&curren;",164],["&yen;",165],["&brvbar;",166] _
        ,["&sect;",167],["&uml;",168],["&copy;",169],["&ordf;",170],["&not;",172],["&shy;",173] _
        ,["&reg;",174],["&macr;",175],["&deg;",176],["&plusmn;",177],["&sup2;",178],["&sup3;",179] _
        ,["&acute;",180],["&micro;",181],["&para;",182],["&middot;",183],["&cedil;",184],["&sup1;",185] _
        ,["&ordm;",186],["&raquo;",187],["&frac14;",188],["&frac12;",189],["&frac34;",190],["&iquest;",191] _
        ,["&Agrave;",192],["&Aacute;",193],["&Atilde;",195],["&Auml;",196],["&Aring;",197],["&AElig;",198] _
        ,["&Ccedil;",199],["&Egrave;",200],["&Eacute;",201],["&Ecirc;",202],["&Igrave;",204],["&Iacute;",205] _
        ,["&Icirc;",206],["&Iuml;",207],["&ETH;",208],["&Ntilde;",209],["&Ograve;",210],["&Oacute;",211] _
        ,["&Ocirc;",212],["&Otilde;",213],["&Ouml;",214],["&times;",215],["&Oslash;",216],["&Ugrave;",217] _
        ,["&Uacute;",218],["&Ucirc;",219],["&Uuml;",220],["&Yacute;",221],["&THORN;",222],["&szlig;",223] _
        ,["&agrave;",224],["&aacute;",225],["&acirc;",226],["&atilde;",227],["&auml;",228],["&aring;",229] _
        ,["&aelig;",230],["&ccedil;",231],["&egrave;",232],["&eacute;",233],["&ecirc;",234],["&euml;",235] _
        ,["&igrave;",236],["&iacute;",237],["&icirc;",238],["&iuml;",239],["&eth;",240],["&ntilde;",241] _
        ,["&ograve;",242],["&oacute;",243],["&ocirc;",244],["&otilde;",245],["&ouml;",246],["&divide;",247] _
        ,["&oslash;",248],["&ugrave;",249],["&uacute;",250],["&ucirc;",251],["&uuml;",252],["&thorn;",254]]
   
	For $x = 0 To Ubound($aEntities)-1
        $sTemp = StringReplace($sTemp,$aEntities[$x][0],Chr($aEntities[$x][1]))
    Next
	
    For $x = 32 To 255
        $sTemp = StringReplace($sTemp,"&#"&$x&";",chr($x))
    Next
	
	For $x = 256 To 10000
        $sTemp = StringReplace($sTemp,"&#"&$x&";",chrw($x))
    Next
	
    Return $sTemp
EndFunc
